/////////////////////////////////////////////////////////////////////////////// //
//
// DeviceRegistry.hxx
//
//   This class keeps up with a list of all of the availible devices and
// allocates them.  It's dervied from the BasicDeviceRegistry
//
// By: Bradford W. Mott
// October 30,1993
//
///////////////////////////////////////////////////////////////////////////////

#ifndef DEVICEREGISTRY_HXX
#define DEVICEREGISTRY_HXX

#include "BasicDeviceRegistry.hxx"

///////////////////////////////////////////////////////////////////////////////
// The DeviceRegistry Class
///////////////////////////////////////////////////////////////////////////////
class DeviceRegistry : public BasicDeviceRegistry {
  private:
    static const DeviceInformation device_info[];

  public:
    DeviceRegistry();

    // Create a device with the given name (return 1=OK,0=ERROR)
    int Create(String& name, String& args, BasicCPU *,
               BasicDevice* &device); 
};
#endif
