///////////////////////////////////////////////////////////////////////////////
//
// main.cxx - The main routine
//
//   The main procedure has to instantiate all of the objects and startup the
// user interface command parser
//
// By: Bradford W. Mott
// Novemeber 13,1993
//
///////////////////////////////////////////////////////////////////////////////

#include "Interface.hxx"
#include "cpu/Hector.hxx"
#include "devices/DeviceRegistry.hxx"
#include "loader/Loader.hxx"

main()
{
 AddressSpace*        addr_space = new AddressSpace(0x0000ffff);
 BasicCPU*            processor  = new Hector(addr_space);
 BasicLoader*         loader     = new Loader(processor);
 BasicDeviceRegistry* registry   = new DeviceRegistry;

 Interface interface(processor, registry, loader);
 interface.CommandLoop();

 delete registry;
 delete loader;
 delete processor;
 delete addr_space;
}

